(function(l, i, v, e) { v = l.createElement(i); v.async = 1; v.src = '//' + (location.host || 'localhost').split(':')[0] + ':35729/livereload.js?snipver=1'; e = l.getElementsByTagName(i)[0]; e.parentNode.insertBefore(v, e)})(document, 'script');
import Vue from 'vue';

var Spinner = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('span',{staticClass:"spinner",style:(_vm.style)})},staticRenderFns: [],_scopeId: 'data-v-39432f99',
  name: 'Spinner',
  props: {
    color: {
      type: String,
      default: '#3498db'
    },
    size: {
      type: Number,
      default: 18
    },
    width: {
      type: Number,
      default: 4
    },
    duration: {
      type: String,
      default: '1s'
    }
  },
  computed: {
    style: function style () {
      return {
        borderTopColor: this.color,
        width: ((this.size) + "px"),
        height: ((this.size) + "px"),
        borderWidth: ((this.width) + "px"),
        animationDuration: this.duration
      }
    }
  }
}

var isPromise = function (obj) {
  return !!obj && (typeof obj === 'object' || typeof obj === 'function') && typeof obj.then === 'function'
};

var isString = function (obj) {
  return typeof obj === 'string'
};

var isObject = function (obj) {
  return obj === Object(obj)
};

var pluginElPropName = '$promiseBtnId';
var elementId = 0;

var spinnerWrapper = function (options) {
  return ("\n  <span class=\"promise-btn__spinner-wrapper\" v-show=\"show\">\n    " + (options.loader) + "\n  </span>")
};

var spinnerRenderer = function (options) {
  return function (h) {
    var obj;

    return h('span', {
      class: ( obj = {
        'promise-btn__spinner-wrapper': true
      }, obj[options.spinnerHiddenClass] = options.spinnerHiddenClass ? !this.show : false, obj),
      directives: [{
        name: 'show',
        value: options.autoHideSpinnerWrapper ? this.show : true
      }]
    }, [
      h(options.loader)
    ])
  }
};

var initSpinner = function (btnEl, options, vnode, isLoaderString) {
  var dummyEl = document.createElement('SPAN');
  btnEl.appendChild(dummyEl);

  var vueSpinnerOptions = {
    el: dummyEl,
    data: { show: false },
    props: {
      parent: {
        type: Object,
        default: function () { return vnode.context; }
      }
    }
  };

  if (isLoaderString) {
    vueSpinnerOptions = Object.assign({}, vueSpinnerOptions,
      {template: options.spinnerWrapper(options)});
  } else {
    vueSpinnerOptions = Object.assign({}, vueSpinnerOptions,
      {render: options.spinnerRenderer(options)});
  }

  return vueSpinnerOptions
};

var enableBtn = function (el, options) {
  if (el.getAttribute('disabled') && options.disableBtn) { el.removeAttribute('disabled'); }
  el.classList.remove(options.btnLoadingClass);
};

var disableBtn = function (el, options) {
  if (options.disableBtn) { el.setAttribute('disabled', 'disabled'); }
  el.classList.add(options.btnLoadingClass);
};

var setupVuePromiseBtn = function (globalOptions) {
  var directive = {
    listeners: {},
    init: function init (el, binding, vnode) {
      var isBindingValueObj = isObject(binding.value);
      var id = el[pluginElPropName] = elementId++;
      var instanceOptions = isBindingValueObj ? binding.value : {};
      var options = Object.assign({}, globalOptions,
        instanceOptions);
      var handler = vnode.data.on && vnode.data.on[options.action] && vnode.data.on[options.action]._withTask;
      var isLoaderString = isString(options.loader);
      var btnEl = el;
      var spinnerVM = null;
      var minTimeoutDone = false;
      var promiseDone = false;

      var handleLoadingFinished = function () {
        if (minTimeoutDone && promiseDone) {
          spinnerVM.show = false;
          minTimeoutDone = false;
          promiseDone = false;
          enableBtn(btnEl, options);
        }
      };

      var beforeResponseHandler = function () {
        scheduled = true;
        disableBtn(btnEl, options);
        if (options.showSpinner) {
          spinnerVM.show = true;
          setTimeout(function () {
            minTimeoutDone = true;
            handleLoadingFinished(minTimeoutDone, promiseDone, spinnerVM);
          }, options.minTimeout);
        }
      };

      var resolveHandler = function () {
        scheduled = false;
        if (options.showSpinner) {
          promiseDone = true;
          handleLoadingFinished(minTimeoutDone, promiseDone, spinnerVM);
        }
      };

      // Register info in listeners object
      directive.listeners[id] = {
        el: el,
        eventType: options.action,
        handler: handler
      };

      // Remove native event listener
      el.removeEventListener(options.action, handler);

      if (!handler) { throw new Error('Please, provide proper handler/action for promise-btn') }
      if (options.action === 'submit') {
        btnEl = el.querySelector('[type="submit"]');
        if (!btnEl) { throw new Error('No submit button found') }
      }

      if (options.showSpinner) {
        var vueSpinnerOptions = initSpinner(btnEl, options, vnode, isLoaderString);
        spinnerVM = new Vue(vueSpinnerOptions);
      }

      var scheduled = false;

      // Set custom event that will replace original listener
      directive.listener = function (e) {
        if (options.disableBtn && scheduled) { return }
        var response = handler(e);
        if (isPromise(response)) {
          beforeResponseHandler();
          response
            .then(resolveHandler)
            .catch(function (e) {
              resolveHandler();
              throw e
            });
        }
      };
    },
    bind: function bind (el, binding, vnode) {
      var ref;

      // Init
      (ref = binding.def).init.apply(ref, arguments);

      // Replace native event listener
      var id = el[pluginElPropName];
      var ref$1 = directive.listeners[id];
      var eventType = ref$1.eventType;
      el.addEventListener(eventType, directive.listener);
    },
    unbind: function unbind (el, binding) {
      var id = el[pluginElPropName];
      var ref = directive.listeners[id];
      var eventType = ref.eventType;
      el.removeEventListener(eventType, directive.listener);
      delete directive.listeners[id];
      delete el[pluginElPropName];
    }
  };
  return directive
};

var defaultOptions = {
  btnLoadingClass: 'loading',
  showSpinner: true,
  action: 'click',
  disableBtn: true,
  spinnerWrapper: spinnerWrapper,
  spinnerRenderer: spinnerRenderer,
  minTimeout: 400,
  spinnerHiddenClass: 'hidden',
  autoHideSpinnerWrapper: false,
  loader: Spinner
};

function install (Vue$$1, options) {
  var globalOptions = Object.assign({}, defaultOptions, options);
  Vue$$1.directive('promise-btn', setupVuePromiseBtn(globalOptions));
}

var main = {
  install: install,
  Spinner: Spinner,
  setupVuePromiseBtn: setupVuePromiseBtn
}

export default main;
